--mobj thinkers

--SOC stuff
freeslot("MT_SLIMECIRC", "MT_SLIMEEYES", "MT_SLIMESPLAT", "MT_SPIKEBOOST", "MT_SLEEPZ", "MT_SPIKESHIELD")

--Yawning, divided in phases
local function Yawn(mo)

	--raising the eyes while stretching them an itty bitty bit
	if mo.yawnStart
		if mo.spriteyscale > FRACUNIT/5 and not mo.yDone
			mo.spriteyscale = $ - FRACUNIT/36
		else
			mo.yDone = true
		end
		if mo.spritexscale < FRACUNIT + FRACUNIT/3 and mo.spriteyscale < FRACUNIT - FRACUNIT/4 and not mo.xDone
			mo.spritexscale = $ + FRACUNIT/74
			if mo.spritexscale >= FRACUNIT + FRACUNIT/3
				mo.xDone = true
			end
		end
		if mo.custz < 15*FRACUNIT
			mo.custz = $ + (FRACUNIT/3) + FRACUNIT/6
			if mo.custz > 4*FRACUNIT then mo.tracer.player.yawnStretch = true end
			if mo.custz >= 15*FRACUNIT then
				mo.yawnStart = false
				mo.yawnEyeUpdown = true
			end
		end
	end
	
	--make the eyes bob a bit up and down when the eyes reach their highest point
	if mo.yawnEyeUpdown
		if not mo.yawnTime then mo.yawnTime = 1 end
		if leveltime%6 > 2
			mo.custz = $ + FRACUNIT/4
		else
			mo.custz = $ - FRACUNIT/4
		end
		mo.yawnTime = $ + 1
		if mo.yawnTime >= 72
			mo.yawnTime = 0
			mo.yawnEyeUpdown = false
			mo.restEyes = true
		end
	end
	
	--and now the eyes go down to rest
	if mo.restEyes
		if mo.custz > 8*FRACUNIT and not mo.idleRest
			mo.custz = $ - (FRACUNIT/3) + FRACUNIT/6
			if mo.custz <= 8*FRACUNIT
				mo.idleRest = true
			end
		end
		if mo.idleRest
			if not mo.idleTimer then mo.idleTimer = 1 end
			mo.idleTimer = $+1
			mo.custz = 8*FRACUNIT + sin(FixedAngle(mo.idleTimer)*FRACUNIT)
		end
		if not (mo.spritexscale == FRACUNIT)
			mo.spritexscale = $ - (abs($)-FRACUNIT)/10
			if mo.spriteyscale > 95*FRACUNIT/100 and mo.spriteyscale < 105*FRACUNIT/100
				mo.spriteyscale = FRACUNIT
			end
		end
	end
end

--Circle effect on air jumps
addHook("MobjSpawn", function(mo)
	mo.spritexscale = 1
	mo.spriteyscale = 1
end, MT_SLIMECIRC)

addHook("MobjThinker", function(mo)
	mo.z = $ - 4*FRACUNIT
	mo.spritexscale = $ + FRACUNIT/5
	mo.spriteyscale = $ + FRACUNIT/5
end, MT_SLIMECIRC)

--Despawning the spike shield for leaving players
addHook("MobjThinker", function(mo)
	if mo.tracer and not mo.tracer.valid
		P_RemoveMobj(mo)
	end
end, MT_SPIKESHIELD)

--Spike boost circle
addHook("MobjSpawn", function(mo)
	mo.spritexscale = 1
	mo.spriteyscale = 1
end, MT_SPIKEBOOST)

addHook("MobjThinker", function(mo)
	P_TeleportMove(mo, mo.tracer.x - cos(mo.tracer.player.drawangle), mo.tracer.y - sin(mo.tracer.player.drawangle), mo.tracer.z + FRACUNIT*12)
	mo.spritexscale = $ + FRACUNIT/14
	mo.spriteyscale = $ + FRACUNIT/14
	mo.rollangle = $ + ANGLE_22h
end, MT_SPIKEBOOST)

--Z bubble when sleeping
addHook("MobjThinker", function(mo)
	if mo.tracer and mo.tracer.valid
		mo.color = mo.tracer.player.skincolor
	end
	if not mo.lifeTime then mo.lifeTime = 1 end
	mo.lifeTime = $+1
	P_TeleportMove(mo, mo.x + mo.xdir, mo.y + mo.ydir, mo.z + FRACUNIT/6)
	mo.rollangle = 0 + FixedAngle(sin(FixedAngle((mo.lifeTime*FRACUNIT)*4))*22)
	if mo.lifeTime == TICRATE*3 then mo.destscale = 1 end
	if mo.lifeTime > TICRATE*4 then P_RemoveMobj(mo) end
end, MT_SLEEPZ)

--Slime eyes
addHook("MobjThinker", function(mo)
	
	if mo.tracer and mo.tracer.player.valid
		
		--making sure the eyes always align with the body
		mo.angle = mo.tracer.player.drawangle
		
		--expressions
		if mo.tracer.state == S_PLAY_PAIN
			mo.state = S_EYHU -- > <
		else
			mo.state = S_EYES -- 0 0
		end
		
		--since we're not a followobj thanks to some jank, we gotta flip our offset manually here
		local extraOffset = 0
		if mo.tracer.player.powers[pw_carry] then extraOffset = $ + 10*FRACUNIT end
		if P_MobjFlip(mo) == 1
			mo.spriteyoffset = 0 + extraOffset
		else
			mo.spriteyoffset = -15*FRACUNIT - extraOffset
		end
		
		--blinking timer
		if not mo.blinkTimer then mo.blinkTimer = 1 end
		mo.blinkTimer = $+1
		
		--ignore all this if we're asleep, naturally
		if not mo.goodnight and not mo.tracer.player.becomeShield and not mo.jompDistort
		
			--blink timer
			if mo.blinkTimer > 10 and mo.tracer and mo.tracer.valid
			and (mo.tracer.player.panim == PA_IDLE or mo.tracer.player.panim == PA_EDGE)
			and P_IsObjectOnGround(mo.tracer)
			and not (mo.blinkTimer%150)
				mo.blink = true
			end
			
			--blinking
			if mo.blink or mo.blonk
				--close...
				if mo.blink
					mo.spriteyscale = $-(FRACUNIT/5)
					mo.custz = $+FRACUNIT
					if mo.spriteyscale <= FRACUNIT/12
						mo.blink = false
						mo.blonk = true
					end
				end
				--...open
				if mo.blonk
					mo.spriteyscale = $ - (abs($)-FRACUNIT)/3
					mo.custz = $/2
					if mo.spriteyscale > 95*FRACUNIT/100 and mo.spriteyscale < 105*FRACUNIT/100
						mo.custz = 1
						mo.spriteyscale = FRACUNIT
						mo.blonk = false
					end
				end
			end
		elseif mo.goodnight
			Yawn(mo)
		end
		
		if not mo.goodnight and not mo.blink and not mo.blonk
			mo.custz = 1
		end
		
		--pre jump distortion
		if mo.jompTimer and mo.jompTimer < 10
			mo.jompTimer = $+1
			mo.spritexscale = $+(FRACUNIT/25)
			mo.spriteyscale = $-(FRACUNIT/25)
			if(mo.jompTimer == 10)
				mo.jompTimer = 0
			end
		end
		
		--self explanatory
		if(mo.squish or mo.afterSquish)
			P_LandingSquish(mo)
		end
		
		--ditto. just don't distort if your player is a shield
		if not P_IsObjectOnGround(mo.tracer) and not mo.tracer.player.becomeShield
			mo.jompDistort = true
		end
		
		--making sure our eye distortions don't get stuck in weird positions during shield form
		if mo.tracer.player.becomeShield
			mo.spritexscale = FRACUNIT
			mo.spriteyscale = FRACUNIT
		end
			
		--Borrowing these distortions from our main body
		if mo.jompDistort and ( not (maptol & TOL_NIGHTS) or (maptol & TOL_NIGHTS and not (mo.tracer.player.nightstime)) )
			mo.spritexscale = mo.tracer.spritexscale
			mo.spriteyscale = mo.tracer.spriteyscale
		end
		
		--transitioning from jump distortion into squishing above
		if mo.jompDistort and P_IsObjectOnGround(mo.tracer)
			mo.spritexscale = FRACUNIT
			mo.spriteyscale = FRACUNIT
			mo.jompDistort = false
			mo.squish = true
		end
	end
	
end, MT_SLIMEEYES)